hdu 2883 kebab(时间区间压缩 dinic)

kebabTime Limit: 2000/1000 MS (Java/Others)Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1243Accepted Submission(s): 516

Problem Description

Almost everyone likes kebabs nowadays (Here a kebab means pieces of meat grilled on a long thin stick). Have you, however, considered about the hardship of a kebab roaster while enjoying the delicious food? Well, here’s a chance for you to help the poor roaster make sure whether he can deal with the following orders without dissatisfying the customers.Now N customers is coming. Customer i will arrive at time si (which means the roaster cannot serve customer i until time si). He/She will order ni kebabs, each one of which requires a total amount of ti unit time to get it well-roasted, and want to get them before time ei(Just at exactly time ei is also OK). The roaster has a big grill which can hold an unlimited amount of kebabs (Unbelievable huh? Trust me, it’s real!). But he has so little charcoal that at most M kebabs can be roasted at the same time. He is skillful enough to take no time changing the kebabs being roasted. Can you help him determine if he can meet all the customers’ demand?Oh, I forgot to say that the roaster needs not to roast a single kebab in a successive period of time. That means he can divide the whole ti unit time into k (1<=k<=ti) parts such that any two adjacent parts don’t have to be successive in time. He can also divide a single kebab into k (1<=k<=ti) parts and roast them simultaneously. The time needed to roast one part of the kebab well is linear to the amount of meat it contains. So if a kebab needs 10 unit time to roast well, he can divide it into 10 parts and roast them simultaneously just one unit time. Remember, however, a single unit time is indivisible and the kebab can only be divided into such parts that each needs an integral unit time to roast well.

Input

There are multiple test cases. The first line of each case contains two positive integers N and M. N is the number of customers and M is the maximum kebabs the grill can roast at the same time. Then follow N lines each describing one customer, containing four integers: si (arrival time), ni (demand for kebabs), ei (deadline) and ti (time needed for roasting one kebab well).There is a blank line after each input block.Restriction:1 <= N <= 200, 1 <= M <= 1,0001 <= ni, ti <= 501 <= si < ei <= 1,000,000

Output

If the roaster can satisfy all the customers, output “Yes” (without quotes). Otherwise, output “No”.

Sample Input

2 101 10 6 32 10 4 22 101 10 5 32 10 4 2

Sample Output

YesNo

Source

题意描述:有n个人来烤肉店吃烤肉,每个人在si 时刻来ei 时刻离开并且点了ni 份,每份烤肉要烤到ti 个单位时间才算烤熟,烤肉店里可以同时烤m份。问是否有一种计划使得n个人都可以拿到自己的ni 份。参考大牛解题思路:这道题本身不是很难,网络流的模型也很常见,但是这道题中(si,ei)的时间跨度很大(1<=si<=ei<=1000000),所以不能把时间区间直接拆分开建立模型,这样顶点个数太多,会超时。这里,介绍一下学到的新技巧,我们可以把时间区间压缩:time[]里保存全部的si 和 ei ,这样time[i]-time[i-1]就表示一段时间区间了,这题和HDU 3572相似,但又不能像那题那样做,因为这题时间长度有点大所以将时间区间当成一个点,将该区间连向超级汇点,容量为区间长度*M将所有客人连向超级源点,容量为烤肉数量*每串烤肉所需时间接下来的难点就是怎么将客人和时间区间连起来了 ,如果时间区间在客人来的时间和走的时间这段区间内,就表明这段时间可以用来帮客人烤肉,所以可以连接,,容量为inf

#include<stdio.h>#include<algorithm>#include<string.h>#include<queue>using namespace std;#define M 3000#define inf 0x3f3f3f3fint head[M],dis[M],st,t,n,m,cnt;struct node{int v,next,w;}mp[M*M];void add(int u,int v,int w){mp[cnt].v=v;mp[cnt].w=w;mp[cnt].next=head[u];head[u]=cnt++;mp[cnt].v=u;mp[cnt].w=0;mp[cnt].next=head[v];head[v]=cnt++;}int bfs(){memset(dis,-1,sizeof(dis));queue <int> q;dis[st]=0;q.push(st);while(!q.empty()){int u=q.front();q.pop();for(int i=head[u];i!=-1;i=mp[i].next){int v=mp[i].v;if( mp[i].w>0 && dis[v]==-1){dis[v]=dis[u]+1;if(v==t) return 1;q.push(v);}}}return 0;}int dinic(int s,int low){//按照注释地方写就会wa,以前这么写就能过啊,这次快wa哭了,,= =+ if(s==t || low==0) return low;int a,ans=low;//ans=0;for(int i=head[s];i!=-1;i=mp[i].next){int v=mp[i].v;if(mp[i].w>0 && dis[v]==dis[s]+1 && (a=dinic(v,min(ans/*low*/,mp[i].w)))){mp[i].w-=a;mp[i^1].w+=a;//ans+=a;//if(ans==low) break;ans-=a;if(ans==0) return low;}}//return ans;return low-ans;}int main(){int tot,count,sum;int s[M],e[M],num[M],ti[M],time[M];while(~scanf("%d%d",&n,&m)){sum=cnt=0;tot=1; count=0;memset(head,-1,sizeof(head));memset(time,0,sizeof(time));for(int i=1;i<=n;i++){scanf("%d%d%d%d",&s[i],&num[i],&e[i],&ti[i]);sum+=num[i]*ti[i];time[tot++]=s[i];time[tot++]=e[i];}sort(time+1,time+tot);for(int i=1;i<tot;i++)//消除重复区域if(time[count]!=time[i])time[++count]=time[i];st=n+count+1;//起点 t=st+1; //汇点 for(int i=1;i<=n;i++)//起点到每个顾客,权值为烤肉数乘以时间add(st,i,num[i]*ti[i]);for(int i=1;i<=count;i++){add(n+i,t,m*(time[i]-time[i-1]));//时间区间到汇点,权值为单位时间完成烤肉m乘以区间长度for(int j=1;j<=n;j++){if(s[j]<=time[i-1]&&e[j]>=time[i])add(j,n+i,inf);//如果顾客的区间段}}int ans=0;while(bfs())ans+=dinic(st,inf);if(sum==ans) printf("Yes\n");else printf("No\n");}return 0;}

做对的事情比把事情做对重要。

hdu 2883 kebab(时间区间压缩 dinic)

相关文章:

你感兴趣的文章:

标签云: